using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Cors;
using Microsoft.AspNetCore.Mvc;
using System;
using WK_KLI_LAPS_Service.App_Data;
using WK_KLI_LAPS_Service.Models.Master;

// For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace WK_KLI_LAPS_Service.Controllers.Master.Unit
{
    [EnableCors("CorsPolicy")]
    [Authorize]
    [ApiController]
    [Route("api/[controller]")]
    public class UnitApiController : ControllerBase
    {
        CommonRepository oCommonRepository = new CommonRepository();

        private IUnitService _Unitservices;
        public UnitApiController(IUnitService UnitServices)
        {
            _Unitservices = UnitServices;

        }


        [Authorize]
        [HttpGet]
        //Code to retrieve all data
        public IActionResult GetAll()
        {
            var _list = _Unitservices.GetAll();
            return Ok(_list);
        }

        [Authorize]
        [HttpGet("GetActiveUnit")]
        //Code to retrieve active data
        public IActionResult GetActiveUnit()
        {
            var _list = _Unitservices.GetActiveUnit();
            return Ok(_list);
        }
        //Code to add new record
        [Authorize]
        [HttpPost("Add")]
        public IActionResult Add([FromBody] unitModel ounitModel)
        {

            int retval = 0;
            try
            {
                retval = _Unitservices.Add(ounitModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to update specific record
        [Authorize]
        [HttpPost("Update")]
        public IActionResult Update([FromBody] unitModel ounitModel)
        {
            int retval = 0;
            try
            {
                retval = _Unitservices.Edit(ounitModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }


        //Code to activate or deactivate specific record
        [Authorize]
        [HttpPost("activeordeactive")]
        public IActionResult Delete([FromBody] unitModel ounitModel)
        {
            int retval = 0;
            try
            {
                retval = _Unitservices.Delete(ounitModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }
        }
    }
}
